﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Windows.Forms;

using System.Windows.Automation;

namespace EncompassAutoStart
{
    public class Utils2
    {
        // app path with backslash
        public static string AppPath()
        {
            return FileDir(Application.ExecutablePath);
        }

        // return backslashed
        public static string FileDir(string sFile)
        {
            int last_slash = sFile.LastIndexOf('\\');
            if (last_slash >= 0) return sFile.Substring(0, last_slash + 1);
            else return sFile;
        }

        public static void MsgBox_ErrorOK(string s)
        {
            // Form w = Form.ActiveForm; 
            MessageBox.Show(s, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        public static string ParseCommandLineParam(string sParam)
        {
            // 1) split cmd line
            string[] args = Environment.GetCommandLineArgs();
            for (int i = 1; i < args.Length - 1; i++)
            {
                if (args[i].Equals(sParam, StringComparison.OrdinalIgnoreCase))
                {
                    return args[i + 1];
                }
            }
            // fallthrough - not found
            return "";
        }

        public static void SetText(AutomationElement element, string s)
        {
            object patternObj;
            if (element.TryGetCurrentPattern(ValuePattern.Pattern, out patternObj))
            {
                ValuePattern valuePattern = (ValuePattern)patternObj;
                if (valuePattern != null)
                {
                    valuePattern.SetValue(s);
                    return;
                }
            }
            // fallthrough - value not set
            throw new Exception("Cannot set element value '" + element.Current.Name + "'");
        }

        public static AutomationElement FindElement(AutomationElement el1, string sNameOrID)
        {
            // 1) check by ID
            TreeScope scope = TreeScope.Descendants;
            Condition condition = new PropertyCondition(AutomationElement.AutomationIdProperty, sNameOrID, PropertyConditionFlags.IgnoreCase);
            AutomationElement el2 = el1.FindFirst(scope, condition);
            if (el2 == null)
            {
                // 2) check by Name
                condition = new PropertyCondition(AutomationElement.NameProperty, sNameOrID, PropertyConditionFlags.IgnoreCase);
                el2 = el1.FindFirst(scope, condition);
            }
            return el2;
        }

        public static void InvokeClick(AutomationElement el)
        {
            InvokePattern ip = el.GetCurrentPattern(InvokePattern.Pattern) as InvokePattern;
            ip.Invoke();
        }


    }
}
